DIM BMX_HDR AS STRING * 32
DIM BMX_ID AS STRING * 3
DIM SHARED BMX_VERSION AS BYTE
DIM SHARED BMX_WIDTH AS WORD FAST
DIM SHARED BMX_HEIGHT AS WORD FAST
DIM SHARED BMX_PALUSED AS BYTE
DIM BMX_FIRSTPAL AS BYTE
DIM BMX_FILEOFFSET AS WORD
DIM BMX_COMPRESS AS BYTE
DIM SHARED BMX_VER AS BYTE
DIM SHARED BMX_BITS AS BYTE
DIM SHARED Is_Supported_BMX AS BYTE
DIM TMPBYTESL AS LONG FAST
DIM TMPBYTES AS WORD FAST
DIM BYTESTOGET AS WORD FAST
DIM BYTES_TO_READL AS LONG FAST
DIM BYTES_TO_READ AS WORD FAST
DIM X AS WORD
DIM Y AS WORD
DIM XR AS BYTE
DIM YR AS WORD
DIM VADDR AS WORD FAST
DIM SHARED BMX_FILENAME AS STRING * 96
DIM TMP AS STRING*32 @$A000

CONST GRAPH_set_colors = $FF29
CONST GRAPH_draw_line = $FF2C


SUB PARSEHEADER() STATIC
    BMX_ID=LEFT$(BMX_HDR,3)
    BMX_VER=ASC(MID$(BMX_HDR,3,1))
    BMX_BITS = ASC(MID$(BMX_HDR,4,1))
    BMX_WIDTH = ASC(MID$(BMX_HDR,6,1)) + (ASC(MID$(BMX_HDR,7,1))*256)
    BMX_HEIGHT = ASC(MID$(BMX_HDR,8,1)) + (ASC(MID$(BMX_HDR,9,1))*256)
    BMX_PALUSED = ASC(MID$(BMX_HDR,10,1))
    BMX_FIRSTPAL = ASC(MID$(BMX_HDR,11,1))
    BMX_FILEOFFSET = ASC(MID$(BMX_HDR,12,1))+(ASC(MID$(BMX_HDR,13,1))*256)
    BMX_COMPRESS= ASC(MID$(BMX_HDR,14,1))
END SUB

FUNCTION OPEN_BMX AS BYTE(BMXFILE AS STRING * 80) STATIC
     IF NOT FILEEXISTS(BMXFILE,8) THEN Is_Supported_BMX=0:RETURN Is_Supported_BMX
     OPEN 4,8,4,BMXFILE+",S,R"
     ASM
       ldx {ScratchBank}
       stx 0
       ldx #4
       jsr {CHKIN}
       lda #32
       sta {TMP}
       ldx #01
       ldy #$A0
       jsr {MACPTR}
       jsr {CLRCHN}
     END ASM
     BMX_HDR = TMP
     CALL PARSEHEADER()
     Is_Supported_BMX = ( (BMX_ID="bmx") AND (BMX_VER = 1) AND (BMX_BITS = 8) AND ((BMX_WIDTH > 0) AND (BMX_WIDTH < 321)) AND ((BMX_HEIGHT > 0) AND (BMX_HEIGHT < 241)) )
     IF NOT Is_Supported_BMX THEN CLOSE 4
     RETURN Is_Supported_BMX
END FUNCTION

SUB SHOWHEADERINFO() STATIC SHARED
   DIM I AS BYTE
   PRINT "{CLR}{13}"
   PRINT "{WHITE}BMX FILE: {LIGHT_GREEN}";BMX_FILENAME
   PRINT "          {YELLOW}";
   FOR I = 1 TO LEN(BMX_FILENAME)
      PRINT "-";
   NEXT I
   PRINT "{13}";
   PRINT ""
   PRINT "{WHITE}        BMX HEADER ID: {GREEN}";BMX_ID
   PRINT "{WHITE}          BMX VERSION: {GREEN}";BMX_VER
   PRINT "{WHITE}            BIT DEPTH: {GREEN}";BMX_BITS
   PRINT "{WHITE}                WIDTH: {GREEN}";BMX_WIDTH
   PRINT "{WHITE}               HEIGHT: {GREEN}";BMX_HEIGHT
   PRINT "{WHITE} PALLETE ENTRIES USED: {GREEN}";BMX_PALUSED
   PRINT "{WHITE}      PAL INDEX START: {GREEN}";BMX_FIRSTPAL
   PRINT "{WHITE} IMG DATA FILE OFFSET: {GREEN}";BMX_FILEOFFSET
   PRINT "{WHITE}    IMAGE COMPRESSION:  {GREEN}";
   IF BMX_COMPRESS > 0 THEN PRINT "LZSA":GOTO ENDHSHOW
   PRINT "NONE"
ENDHSHOW:
   PRINT "{WHITE}"
   PRINT ""
END SUB

SUB READSMALLIMAGE() STATIC
 DIM A AS BYTE
    A=0
    XR = 0
    YR = 0
 X = ((XLIMIT+1)-BMX_WIDTH)/2
 IF BMX_HEIGHT>240 THEN BMX_HEIGHT=240
 IF BMX_HEIGHT=240 THEN Y=0
 IF BMX_HEIGHT <> 240 THEN Y = ((YLIMIT+1)-BMX_HEIGHT)/2

   ASM
     lda %00010000
     sta {VERA_ADDR_HI}
     lda {X}
     sta {R0L}
     lda {X}+1
     sta {R0H}
     lda #0
     sta {R1H}
     lda {Y}
     sta {R1L}
     jsr {FB_cursor_position}
    END ASM

  BYTESTOGET = BMX_WIDTH
  FOR I = 1 TO BMX_HEIGHT
     TMPBYTES=0
     DO
      BYTES_TO_READ=BYTESTOGET-TMPBYTES
      IF BYTES_TO_READ>255 THEN BYTES_TO_READ=255
      ASM
       lda {BYTES_TO_READ}
       ldx #$23
       ldy #$9F
       sec
       jsr {MACPTR}
       clc
       txa
       adc {TMPBYTES}
       sta {TMPBYTES}
       tya
       adc {TMPBYTES}+1
       sta {TMPBYTES}+1
      END ASM
    LOOP WHILE (TMPBYTES < BYTESTOGET)
    ASM
     jsr {FB_cursor_nextline}
    END ASM
  NEXT I
  ASM
   jsr {CLRCHN}
  END ASM
  CLOSE 4
END SUB


SUB LOADBMX(BMXFILE AS STRING*80) STATIC SHARED
DIM A AS BYTE FAST
     ERRMSG=""
     IF NOT OPEN_BMX(BMXFILE) THEN
       ERRMSG="bmx error"
       IF BMX_ID<>"bmx" THEN ERRMSG=ERRMSG+ " not a bmx file":EXIT SUB
       IF BMX_BITS<>8 THEN ERRMSG= ERRMSG+ STR$(BMX_BITS)+" bits not supported":EXIT SUB
       IF BMX_VER<>1 THEN ERRMSG= ERRMSG+" version not supported!":EXIT SUB
       EXIT SUB
     END IF

REM READ IN THE PALETTE

    TMPBYTES=0
    BYTESTOGET = CWORD(BMX_PALUSED)*2
    IF BYTESTOGET=0 THEN BYTESTOGET=512
    VADDR = $FA00 + CWORD(BMX_FIRSTPAL)*2

    ASM
     ldx #4
     jsr {CHKIN}
     lda #0
     sta {VERA_CTRL}
     lda {VADDR}
     sta {VERA_ADDR_LOW}
     lda {VADDR}+1
     sta {VERA_ADDR_MID}
     lda #%00010001
     sta {VERA_ADDR_HI}
    END ASM

DO
   BYTES_TO_READ=BYTESTOGET-TMPBYTES
   IF BYTES_TO_READ>255 THEN BYTES_TO_READ=255
   ASM
    lda {BYTES_TO_READ}
    ldx #$23
    ldy #$9F
    sec
    jsr {MACPTR}
    clc
    txa
    adc {TMPBYTES}
    sta {TMPBYTES}
    tya
    adc {TMPBYTES}+1
    sta {TMPBYTES}+1
   END ASM
LOOP WHILE (TMPBYTES < BYTESTOGET)

REM NOW WE LOAD THE IMAGE TO VERA GRAPHICS BUFFER
   IF BMX_WIDTH < 320 THEN
      CALL READSMALLIMAGE()
      EXIT SUB
    END IF
    BYTES_TO_READL = CLONG(BMX_WIDTH) * CLONG(BMX_HEIGHT)
    ASM
      lda %00010000
      sta {VERA_ADDR_HI}
    END ASM
    IF BMX_HEIGHT=240 THEN Y=0 ELSE Y=(((YLIMIT+1)-BMX_HEIGHT)/2)
    ASM
     lda #0
     sta {R0L}
     sta {R0H}
     sta {R1H}
     lda {Y}
     sta {R1L}
     jsr {FB_cursor_position}
    END ASM
    A=0
    XR = 0
    YR = 0
    TMPBYTESL=0

  DO
    TMPL = BYTES_TO_READL - TMPBYTESL
    IF TMPL > 511 THEN A=0
    IF TMPL < 512 THEN A=255
    IF TMPL < 255 THEN A=TMPL
    ASM
     lda {A}
     ldx #$23
     ldy #$9F
     sec
     jsr {MACPTR}
     stx {XR}
     sty {YR}
    END ASM
    TMPBYTESL = TMPBYTESL + SHL(YR,8) + XR
 LOOP UNTIL (TMPBYTESL = BYTES_TO_READL)
 ASM
  jsr {CLRCHN}
 END ASM
 CLOSE 4
END SUB




SUB GRAPH_clr() STATIC SHARED
 ASM
  jmp $FF23
 END ASM
END SUB

SUB DRAWLINE(X1 AS INT, Y1 AS INT, X2 AS INT, Y2 AS INT, COLOUR AS BYTE) STATIC SHARED
 ASM
  lda {COLOUR}
  jsr {GRAPH_set_colors}
  ldx #0
  lda {X1}
  sta {R0L}
  lda {X1}+1
  sta {R0H}
  lda {Y1}
  sta {R1L}
  stx {R1H}
  lda {X2}
  sta {R2L}
  lda {X2}+1
  sta {R2H}
  lda {Y2}
  sta {R3L}
  stx {R3H}
  jmp {GRAPH_draw_line}
 END ASM
END SUB
